#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#			  Última actualización: 21-enero-2019		    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
###comercialdaemon.sh -rev: 25/01/2020
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 22/07/2019
# ver: 1.0 beta
# Script para exportar data de G-Radio

#echo "Comercial Daemon"
#Función que carga los lists de eventos y comerciales
function comercialplay() {
	#echo "Ejecuta funcioncomercialplay"
	#duracionacumulada=0
	if [[ $evento = 1 ]]; then
		carpeta="eventos"
	else
		if [[ $evento = 0 ]]; then
			carpeta="comerciales"
			else 

			if [[ $evento = 2 ]]; then
			carpeta="eventos-espera"
			fi
		fi	
	fi

	acciones=`grep -c $ $HOME/.gradio/data/$carpeta/$hora/$minutocarga.com`
	accion=1
	while [[ $accion -le $acciones ]]; do
		action="`sed -n $accion"p" $HOME/.gradio/data/$carpeta/$hora/$minutocarga.com`"
		actionbase=`echo "$action"|awk -F"|" '{print $1}'`
		habil=`echo "$action"|awk -F"|" '{print $2}'|grep $dia`
		inicio=`echo "$action"|awk -F"|" '{print $3}'`
		final=`echo "$action"|awk -F"|" '{print $4}'`
		now=`date +%Y%m%d` 
		lista=`echo $actionbase|awk -F"|" '{ print $1 }'|awk -F"." '{ print $NF }'`
		stream=`echo "$actionbase"|grep "http://"`
		#echo "lista: "$lista

			if [ -d "$actionbase" ]; then
				comercialrandom=`/bin/ls -1 "$actionbase" | sort --random-sort | head -1`
				ruta="$actionbase/$comercialrandom"
				nombrebase=`echo "$ruta" |awk -F/ '{print $NF}'`
				extension="${nombrebase##*.}"
				validado=`grep -i $extension $HOME/.gradio/data/extensiones`
				if [ "$validado" != "" ]; then
					#echo "ruta: " $ruta
					actionbase="$ruta"
				else
					echo "Desde comercialdaemon4.sh, el archivo "$actionbase"/"$comercialrandom" parece no ser de audio" >> $HOME/.gradio/data/tmp/log
				fi 
			fi

		if [[ $lista = "gradio" ]]; then
			ruta="$actionbase"
		fi

		if [[ "$actionbase" != "" ]]; then
			if [[ $now -ge $inicio && $now -le $final  && $habil -gt 0 ]]; then  
				modo=`cat $HOME/.gradio/data/tmp/modo`
				semiauto=`cat $HOME/.gradio/data/tmp/listavacia`
				
				if [[ $modo = "1" && $semiauto = "0" ]]; then

					if [[ $evento = 1 ]]; then
						nbaseev=`echo "$actionbase"|awk -F/ '{print $NF}'`
						echo "$actionbase" >> $HOME/.gradio/data/tmp/eventoslist
						echo "<font size='1' color='blue'><b>$nbaseev</b></font>" >> $HOME/.gradio/data/tmp/eventoslistweb

							if [[ $lista = "" ]]; then
								duracion=`mplayer -ao null -identify -frames 0 "$actionbase" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`						
								duracionview=$(printf '%dh:%dm:%ds\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
							else
								if [[ $stream != "" ]]; then
									duracionview=`echo "$stream"|awk -F" " '{ print $4 }'`
									#echo "stream: $stream"
									duracionview=$(printf '%d:%d:%d\n' $(($duracionview/3600)) $(($duracionview%3600/60)) $(($duracionview%60)))
								else
									duracionview="--:--:--"
								fi
							fi
						echo "$nbaseev" "["$duracionview"]" >> $HOME/.gradio/data/tmp/eventoslistwebg3 
						#echo "CargalistaEventos..................."
						#echo duracionacumulada $duracionacumulada
							#echo "coincidencia en" $HOME/.gradio/data/$carpeta/$hora/$minutocarga.com

					fi #evento =1

					if [[ $evento = 2 ]]; then
						nbaseev=`echo "$actionbase"|awk -F/ '{print $NF}'`
						echo "$actionbase" >> $HOME/.gradio/data/tmp/eventos-esperalist
						echo "<font size='1' color='blue'><b>$nbaseev</b></font>" >> $HOME/.gradio/data/tmp/eventos-esperalistweb
							if [[ $lista = "" ]]; then
								duracion=`mplayer -ao null -identify -frames 0 "$actionbase" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`
								duracionview=$(printf '%dh:%dm:%ds\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))				
							else
								if [[ $stream != "" ]]; then
									duracionview=`echo "$stream"|awk -F" " '{ print $4 }'`
									#echo "stream: $stream"
									duracionview=$(printf '%d:%d:%d\n' $(($duracionview/3600)) $(($duracionview%3600/60)) $(($duracionview%60)))
								else
									duracionview="--:--:--"
								fi
							fi
						echo "$nbaseev" "["$duracionview"]" >> $HOME/.gradio/data/tmp/eventos-esperalistwebg3 
						echo "CargalistaEventos..................."
						#echo duracionacumulada $duracionacumulada
							#echo "coincidencia en" $HOME/.gradio/data/$carpeta/$hora/$minutocarga.com

					fi #evento =2
				else
					echo "De comercialdaemon4.sh, Modo manual, no se cargaron eventos" > $HOME/.gradio/data/tmp/currentcomercial.txt
					echo "`date`: De comercialdaemon4.sh, Modo manual, no se cargaron eventos" >> $HOME/.gradio/data/tmp/log
				fi # eventos con modo automático


				if [[ $evento = 0 ]]; then
					nbasecom=`echo "$actionbase"|awk -F/ '{print $NF}'`
					if [[ $lista = "" ]]; then
						duracion=`mplayer -ao null -identify -frames 0 "$actionbase" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`						
						duracionview=$(printf '%d:%d:%d\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
					else
						duracionview="--:--:--"
					fi
					echo -e "$actionbase \t $duracionview"  >> $HOME/.gradio/data/tmp/comercialeslist4
					#echo "CargalistaComerciales..................."
					#echo "coincidencia en" $HOME/.gradio/data/$carpeta/$hora/$minutocarga.com
				fi #evento=0			
			fi #now
		fi #actionbase !=""
		accion=$(($accion+1))
	done #accion -le acciones
}
#Fin funcion

####################################################################################################################################
###########################################INICIO COMERCIAL DAEMON##################################################################
####################################################################################################################################

infinito=1
while [ $infinito = 1 ]; do
	hora=`date  +%-H` 
	dia=`date +%u`
	minuto=`date +%-M`
	segundo=`date +%-S`
	anio=`date +%Y`

	if [[ $minuto -eq 0 ]]; then
		sleep 1
		if [[ -f $HOME/.gradio/data/tmp/tonohora ]]; then
			tonohora=`cat $HOME/.gradio/data/tmp/tonohora`
		fi
		if [[ $tonohora = 1 ]]; then
			$HOME/.gradio/bin/tono-hora.sh
		fi
		if [[ $hora = 0 ]]; then
			$HOME/.gradio/bin/tiempo-stats-temas.sh anio &
		fi
		$HOME/.gradio/bin/tiempo-stats.sh &
		ranura=`echo "$hora-$(($hora+1)).mus"`
		ranuraprevia=`echo "$(($hora-1))-$hora.mus"`

		secuencia=`diff $HOME/.gradio/data/parrilla/$dia/$ranura $HOME/.gradio/data/parrilla/$dia/$ranuraprevia`
		#echo "secuencia" $secuencia
		#Vaciar playlist por cambio de parrilla
		if [[ "$secuencia" != "" ]]; then
			echo `date` >>  $HOME/.gradio/data/tmp/gr-log-parrilla
			echo "vacio la lista por cambio de parrilla - $ranura - $ranuraprevia" >> $HOME/.gradio/data/tmp/gr-log-parrilla
			#$HOME/.gradio/bin/vaciarlista4.sh
			#echo "de comercialdaemon se apagasemiautomático"
			$HOME/.gradio/bin/vaciarlista4.sh &
			sleep 1 #tiempo para lanzar caciar playlist
		fi
	fi

	while [ $segundo -lt 58 ]; do
		sleep 2
		segundo=`date +%-S`
	done

	evento=0
	minutocarga=$(($minuto+1))
	
	############## Verifica si hay eventos #################################################################
	if [ $minutocarga -lt 60 ]; then		
		if [ -s $HOME/.gradio/data/eventos/$hora/$minutocarga.com ]; then
		evento=1
		avanzar=1
		#echo "coincidencia apriori en" $HOME/.gradio/data/eventos/$hora/$minutocarga.com
		comercialplay
		fi
	else		
		hora=$(($hora+1))
		minutocarga=$(($minutocarga-60))			
		if [ -s $HOME/.gradio/data/eventos/$hora/$minutocarga.com ]; then
			evento=1
			avanzar=1
			#echo "coincidencia apriori en" $HOME/.gradio/data/eventos/$hora/$minutocarga.com
			comercialplay
		fi								
	fi
	############## Verifica si hay eventos en espera #################################################################
	if [ $minutocarga -lt 60 ]; then		
		if [ -s $HOME/.gradio/data/eventos-espera/$hora/$minutocarga.com ]; then
			evento=2
			saltar=1
			#echo "coincidencia apriori en" $HOME/.gradio/data/eventos-espera/$hora/$minutocarga.com
			comercialplay
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
		fi
	else 		
		hora=$(($hora+1))
		minutocarga=$(($minutocarga-60))			
		if [ -s $HOME/.gradio/data/eventos-espera/$hora/$minutocarga.com ]; then
			evento=2
			saltar=1
			echo "coincidencia apriori en" $HOME/.gradio/data/eventos-espera/$hora/$minutocarga.com
			comercialplay
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
		fi								
	fi
	############## Verifica si hay comerciales #################################################################
	evento=0
	#minutocarga=$(($minuto+1))
	if [ $minutocarga -lt 60 ]; then		
		if [ -s $HOME/.gradio/data/comerciales/$hora/$minutocarga.com ]; then
			evento=0
			#echo "coincidencia apriori en" $HOME/.gradio/data/comerciales/$hora/$minutocarga.com
			comercialplay
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
		fi
	else 				
		hora=$(($hora+1))
		minutocarga=$(($minutocarga-60))	
		#echo "$HOME/.gradio/data/comerciales/$hora/$minutocarga.com"		
		if [ -s $HOME/.gradio/data/comerciales/$hora/$minutocarga.com ]; then
		evento=0
		comercialplay
		#echo "comercial en la siguiente hora"
		#echo "coincidencia aprior en" $HOME/.gradio/data/comerciales/$hora/$minutocarga.com
		$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
		fi								
	fi			

	############# Si hay eventos le da paso con siguiente4.sh
	cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventoslist`
	eventosplay=`cat $HOME/.gradio/data/tmp/eventosplay`
	if [[ $cnelineas -ge 1 && $avanzar = 1 ]]; then
		#echo 1 > $HOME/.gradio/data/tmp/eventosplay
		modo=`cat $HOME/.gradio/data/tmp/modo`
		sleep 2
		gradioauto=`ps -x|grep -v grep|grep .gradio/bin/gradioauto4.sh`
		if [[ $modo = 1 && $gradioauto != "" && $eventosplay = 0 ]]; then
			#Vaciar eventos previos			
			$HOME/.gradio/bin/siguiente4.sh
		else	
		if [[ $modo = 1 && $gradioauto = "" ]]; then
		echo "Detenido" > $HOME/.gradio/data/tmp/currentcomercial.txt;
		echo "no se emitieron eventos automáticos" > $HOME/.gradio/data/tmp/currentsong.txt;
		echo "" > $HOME/.gradio/data/tmp/eventoslist
		sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
		echo "" > $HOME/.gradio/data/tmp/eventoslistwebg3
		sed -i "1d" $HOME/.gradio/data/tmp/eventoslistwebg3
		fi
	fi
	saltar=1

	fi
		while [[ $minuto = `date +%-M` ]]; do
		sleep 4
		done
done
