#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#	  Última actualización: 28-Jul-2011    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	        #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.    #
#	    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.	    #
#	    #
############################################################################# 
###comercialdaemon.sh -rev: 22/07/2019
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 01/08/2019
# ver: 1.0 beta
# Script para fadeout G-Radio
origen=$1
#echo "inicio fadeoutparrilla.sh..... origen=$1"

volup=`cat  ~/.gradio/data/tmp/upvol`
voldown=`cat  ~/.gradio/data/tmp/downvol`
pspar=`ps uax|grep -v grep|grep .gradio/data/tmp/par.fifo`
psimpar=`ps uax|grep -v grep|grep .gradio/data/tmp/impar.fifo`
comerciales=`ps ax|grep "/data/tmp/slave.txt"|grep -v grep|awk -F" " '{ print $1 }'`

if [[ $pspar != "" ]]; then 
#	echo "bajando volume a par"
	fifofile="$HOME/.gradio/data/tmp/par.fifo"
	proceso=`ps ax|grep "$fifofile"|grep -v grep|awk -F" " '{ print $1 }'`

	down=$volup
	while [[ $down -ge 1  ]]; do
		echo "set_property volume $down" > $fifofile
		down=$(($down -2))
		#echo $down
		sleep 0.05
	done
	up=$voldown
	while [[ $up -le $volup  ]]; do
		echo "set_property volume $up" > $fifofile
		up=$(($up +2))
	done
fi

if [[ $psimpar != "" ]]; then 
#	echo "bajando volume a impar"
	fifofilei="$HOME/.gradio/data/tmp/impar.fifo"
	procesoi=`ps ax|grep "$fifofilei"|grep -v grep|awk -F" " '{ print $1 }'`
	down=$volup
	while [[ $down -ge 1  ]]; do
		echo "set_property volume $down" > $fifofilei
		down=$(($down -2))
		#echo $down
		sleep 0.05
        done
        up=$voldown
	while [[ $up -le $volup  ]]; do
		echo "set_property volume $up" > $fifofilei
		up=$(($up +2))
        done
fi

#echo "proceso: $proceso procesoi: $procesoi comerciales: $comerciales"
eventosplay=`cat $HOME/.gradio/data/tmp/eventosplay`
if [[ $comerciales != "" && $eventosplay = 0 && $proceso = "" && $procesoi = "" ]];then
	#echo "comercial killed"
	kill -9 $comerciales
fi

if [[ $proceso != "" ]];then
	echo "quit" > $fifofile &
fi

if [[ $procesoi != "" ]];then
	echo "quit" > $fifofilei &
fi
echo "0" > $HOME/.gradio/data/tmp/porciento
exit 0
