#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  	    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 24/07/2019
# ver: 1.0 estable
# Script para exportar data de G-Radio

function tiempo() {
	stream=`echo "$1"|grep "http://"`
	#echo "stream: $stream"
	if [[ $stream != "" ]];then
		duracion=`echo "$1"|awk -F" " '{ print $4 }'`
		duracion=$(printf '%d:%d:%d\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
		return $segundos
	else
		lista=`echo "$1"|awk -F"|" '{ print $1 }'|awk -F"." '{ print $NF }'`
		#echo "lista:" $lista
		tiempos=`mediainfo --Inform="Audio;%Duration% " "$1"`
		duracion=0
		if [[ $1 == "Hora" ]]; then
			duracion="-:--:--"
		elif [[ $lista == "gradio" ]]; then
			duracion="Lista"
		else
			for i in $tiempos; do
				if [[ $i -gt $duracion ]]; then
					duracion=$i
				fi 
			done
			#echo "tiempos: $tiempos 1: $1 duracion: $duracion"
			duracion=$(($i/1000))
			duracion=$(printf '%d:%d:%d\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
		fi
		return $segundos
	fi
}
###############INICIO PROGRAMA######################
usuario=`whoami`
ruta="$HOME/.gradio/data"
dia=`` 
## Limpia el visor
	cat /dev/null > $ruta/tmp/visor-pauta
	cat /dev/null > $ruta/tmp/visor-pautaweb
	cat /dev/null > $ruta/tmp/visor-pautawebg3
#while [ $salir=0 ]; do
	minuto=`date  +%-M`
	hora=`date  +%-H` 
	dia=`date +%u`
	minuto=`date +%-M`
		#echo "dia" $dia "Hora" $hora "minuto" $minuto
slide=0
progreso=0
(
while [ $slide -le 23 ]; do
minslide=0
echo $progreso

while [ $minslide -le 59 ]; do

	for pautaje in $( echo eventos comerciales eventos-espera ); do
	#echo "pautaje" $pautaje
		if [ -s "$ruta/$pautaje/$slide/$minslide.com" ]
		then
			etiqueta=0
			pauta=""
			data[2]=100000000
		while read comercial;
		do
			inicio=`date +%s` 
			now=`date +%Y%m%d` 
		
				IFS="|"
				n=0
				for WORD in $comercial
				do
				data[$n]=$WORD
				n=$(($n+1))
				done
				IFS=" "
			dia=`date +%u`
			habil=`echo ${data[1]}|sed -ne /$dia/p`	
			#Etiqueta

			if [[ $now -ge ${data[2]} && $now -le ${data[3]}  && $habil -gt 0 ]]; then  
					if [ $etiqueta = 0 ];
					then
					echo $slide":"$minslide" --> $pautaje" >> $ruta/tmp/visor-pauta
					echo $slide":"$minslide" --> $pautaje" >> $ruta/tmp/visor-pautaweb
					echo $slide":"$minslide" --> $pautaje" >> $ruta/tmp/visor-pautawebg3
					etiqueta=1
					fi 
				actionbase=`echo "${data[0]}"|awk -F"|" '{print $1}'`
				dias=`echo "${data[1]}"|awk -F"|" '{print $1}'`
				inicio=`echo "${data[2]}"|awk -F"|" '{print $1}'`
				fin=`echo "${data[3]}"|awk -F"|" '{print $1}'`

				pauta="$actionbase"  					

				if [ -d "$actionbase" ]; then
					comercialrandom=`/bin/ls -1 "$actionbase" | sort --random-sort | head -1`
					#echo "comercialrandom" $comercialrandom
					actionbase=`echo "$comercial"|awk -F"|" '{print $1}'`
					rutacom="$actionbase/$comercialrandom"
					nombrebase=`echo "$rutacom" |awk -F/ '{print $NF}'`
					extension="${nombrebase##*.}"
					validado=`grep -i $extension $ruta/extensiones`

					if [ "$validado" != "" ]; then
					pauta="$rutacom"
					fi 
				fi
				#echo "pauta: $pauta"
			if  [[ -f "$pauta" ]]; then
				tiempo  "$pauta"
			fi
			
			stream=`echo "$pauta"|grep "http://"`
			LineIn=`echo $pauta|grep PlugLineInGradio`
				
				if [[ $stream != "" ]];then
					duracion=`echo "$pauta"|awk -F" " '{ print $4 }'|sed s/"\/"/":"/g`
					duracion=$(printf '%d:%d:%d\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
					comercial_pautado=`echo "$pauta"|awk -F" " '{ print $5 }'|sed s/"\/"/":"/g`
					#echo "comstr $comercial_pautado"
					echo "$comercial_pautado"".stream |"$duracion"|"$dias"|"$inicio"|"$fin >> $ruta/tmp/visor-pauta
					#echo "$comercial_pautado" "|"$duracion"|"$dias"|"$inicio"|"$fin
					echo "<font size='1' color='blue'><b>$comercial_pautado</b></font>" >> $ruta/tmp/visor-pautaweb
					echo "$comercial_pautado" >> $ruta/tmp/visor-pautawebg3
				elif [[ $LineIn != "" ]]; then
					pauta=`echo $LineIn|awk -F" " '{ print $1}'`
					duracion=`echo "$LineIn"|awk -F" " '{ print $3 }'|sed s/"\/"/":"/g`
					duracion=$(printf '%d:%d:%d\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
					comercial_pautado=`echo "$LineIn"|awk -F" " '{ print $1 }'|sed s/"\/"/":"/g`
					#echo "comstr $comercial_pautado"
					echo "$comercial_pautado"".LineIn |"$duracion"|"$dias"|"$inicio"|"$fin >> $ruta/tmp/visor-pauta
					#echo "$comercial_pautado" "|"$duracion"|"$dias"|"$inicio"|"$fin
					echo "<font size='1' color='blue'><b>$comercial_pautado</b></font>" >> $ruta/tmp/visor-pautaweb
					echo "$comercial_pautado" >> $ruta/tmp/visor-pautawebg3
				elif [[ $pauta != "" ]]; then			
					comercial_pautado=`echo $pauta|sed s/"\/home\/$usuario\/"//g`
					echo "$comercial_pautado" "|"$duracion"|"$dias"|"$inicio"|"$fin >> $ruta/tmp/visor-pauta
					nombrebase=`echo "${data[0]}" |awk -F/ '{print $NF}'`
					echo "<font size='1' color='blue'><b>$nombrebase</b></font>" >> $ruta/tmp/visor-pautaweb
					echo "$nombrebase" >> $ruta/tmp/visor-pautawebg3
				fi

			fi				
		done < $ruta/$pautaje/$slide/$minslide.com
		fi
	done #for pautaje
minslide=$(($minslide + 1))	
done #while minslide
slide=$(($slide + 1))
#echo "actualizando: " $slide":00 horas"
#echo -en "\e[1A"
progreso=$(($progreso+4))
done #while slide
)|
    zenity  --progress \
            --title="Actualizar Pautaje" \
            --auto-close \
            --text="Actualizando Pautaje" \
            --percentage=0
    if [ "$?" = -1 ] ; then
        zenity  --error \
                --text="Actualización cancelada."
    fi
exit
